﻿namespace WFADataSet;

interface

uses
  System.Drawing,
  System.Collections,
  System.Collections.Generic,
  System.Windows.Forms,
  System.Data,
  System.ComponentModel;

type
  /// <summary>
  /// Summary description for MainForm.
  /// </summary>
  MainForm = partial class(System.Windows.Forms.Form)
  private
      var xdsColecaoTabela:DataSet := new DataSet();
      var xdtCliente:DataTable := new DataTable("Cliente");
      var xdtPedido:DataTable := new DataTable("Pedido");
      method MainForm_Load(sender: System.Object; e: System.EventArgs);
      method toolStripButton1_Click(sender: System.Object; e: System.EventArgs);
      method toolStripButton2_Click(sender: System.Object; e: System.EventArgs);
      method toolStripButton3_Click(sender: System.Object; e: System.EventArgs);
      method toolStripButton4_Click(sender: System.Object; e: System.EventArgs);
      method toolStripButton5_Click(sender: System.Object; e: System.EventArgs);
      method toolStripButton6_Click(sender: System.Object; e: System.EventArgs);
  protected
    method Dispose(disposing: Boolean); override;
  public
    constructor;
  end;

implementation

{$REGION Construction and Disposition}
constructor MainForm;
begin
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent();

  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

method MainForm.Dispose(disposing: Boolean);
begin
  if disposing then begin
    if assigned(components) then
      components.Dispose();

    //
    // TODO: Add custom disposition code here
    //
  end;
  inherited Dispose(disposing);
end;
{$ENDREGION}

method MainForm.MainForm_Load(sender: System.Object; e: System.EventArgs);
begin
  
end;

method MainForm.toolStripButton1_Click(sender: System.Object; e: System.EventArgs);
begin
    {$Region Criar a coluna de identificação do cliente}
    var xdcGenerica:DataColumn  := new DataColumn();
    xdcGenerica.ColumnName:="IdCliente";
    xdcGenerica.DataType:= System.Type.GetType("System.Int32");
    xdcGenerica.Caption:="Código do Cliente";
    xdcGenerica.AutoIncrement:= true;
    xdcGenerica.AllowDBNull:=false;
    xdcGenerica.AutoIncrementStep:=1;
    xdcGenerica.ReadOnly:=true;
    xdcGenerica.Unique:=true;
    xdtCliente.Columns.Add(xdcGenerica);
    {$endregion}

    {$Region Criar a coluna nome do cliente}
    xdcGenerica := new DataColumn();
    xdcGenerica.ColumnName := "NomeCliente";
    xdcGenerica.DataType := System.Type.GetType("System.String");
    xdcGenerica.Caption := "Nome";
    xdcGenerica.MaxLength := 40;
    xdcGenerica.AllowDBNull := false;
    xdcGenerica.Unique := true;
    xdtCliente.Columns.Add(xdcGenerica);
    {$endregion}

    {$Region Criar a coluna endereço do cliente}
    xdcGenerica := new DataColumn();
    xdcGenerica.ColumnName := "EnderecoCliente";
    xdcGenerica.DataType := System.Type.GetType("System.String");
    xdcGenerica.Caption := "Endereço";
    xdcGenerica.MaxLength := 60;
    xdcGenerica.AllowDBNull := false;
    xdtCliente.Columns.Add(xdcGenerica);
    {$endregion} 

    {$Region Criar a coluna idade do cliente}
    xdcGenerica := new DataColumn();
    xdcGenerica.ColumnName := "IdadeCliente";
    xdcGenerica.DataType := System.Type.GetType("System.Byte");
    xdcGenerica.Caption := "Idade";
    xdcGenerica.AllowDBNull := false;
    xdtCliente.Columns.Add(xdcGenerica);
    {$endregion}

    {$Region Adicionar a tabela na coleção}
    xdsColecaoTabela.Tables.Add(xdtCliente);
    {$endregion}
end;

method MainForm.toolStripButton2_Click(sender: System.Object; e: System.EventArgs);
begin
    {$Region Criar a coluna de identificação do pedido}
    var xdcGenerica:DataColumn := new DataColumn();
    xdcGenerica.ColumnName := "IdPedido";
    xdcGenerica.DataType := System.Type.GetType("System.Int32");
    xdcGenerica.Caption := "Código do Pedido";
    xdcGenerica.AutoIncrement := true;
    xdcGenerica.AllowDBNull := false;
    xdcGenerica.AutoIncrementStep := 1;
    xdcGenerica.AutoIncrementSeed := 1;
    xdcGenerica.ReadOnly := true;
    xdcGenerica.Unique := true;
    xdtPedido.Columns.Add(xdcGenerica);
    {$endregion}

    {$Region Criar a coluna de identificação do cliente}
    xdcGenerica := new DataColumn();
    xdcGenerica.ColumnName := "IdCliente";
    xdcGenerica.DataType := System.Type.GetType("System.Int32");
    xdcGenerica.Caption := "Código do Cliente";
    xdcGenerica.AllowDBNull := false;
    xdtPedido.Columns.Add(xdcGenerica);
    {$endregion}
            
    {$Region Criar a coluna data do pedido}
    xdcGenerica := new DataColumn();
    xdcGenerica.ColumnName := "DataPedido";
    xdcGenerica.DataType := System.Type.GetType("System.DateTime");
    xdcGenerica.Caption := "Data do Pedido";
    xdcGenerica.AllowDBNull := false;
    xdtPedido.Columns.Add(xdcGenerica);
    {$endregion}

    {$Region Criar a coluna Total}
    xdcGenerica := new DataColumn();
    xdcGenerica.ColumnName := "TotalPedido";
    xdcGenerica.DataType := System.Type.GetType("System.Decimal");
    xdcGenerica.Caption := "Total do Pedido";
    xdcGenerica.AllowDBNull := false;
    xdtPedido.Columns.Add(xdcGenerica);
    {$endregion}

    {$Region Adicionar a tabela na coleção}
    xdsColecaoTabela.Tables.Add(xdtPedido);
    {$endregion}
end;

method MainForm.toolStripButton3_Click(sender: System.Object; e: System.EventArgs);
begin
    {$Region Criar a chave estrangeira}
  var xFk :ForeignKeyConstraint  := new ForeignKeyConstraint
        ("ClienteVsPedido", 
            xdtCliente.Columns["IdCliente"], 
            xdtPedido.Columns["IdCliente"]
        );

  xFk.AcceptRejectRule := AcceptRejectRule.Cascade;
  xdtPedido.Constraints.Add(xFk);
  {$endregion}
end;

method MainForm.toolStripButton4_Click(sender: System.Object; e: System.EventArgs);
begin
   {$Region Criar o relacionamento}
    var xdRelation:DataRelation:= new DataRelation(
        "ClienteVsPedido", xdtCliente.Columns["IdCliente"], 
        xdtPedido.Columns["IdCliente"]
        );

    xdRelation.Nested := true; //Navegar entre as tabelas relacionadas
    xdsColecaoTabela.Relations.Add(xdRelation);
    {$endregion}
end;

method MainForm.toolStripButton5_Click(sender: System.Object; e: System.EventArgs);
begin
       {$Region Cliente 01}
    var xdrow :DataRow:= xdsColecaoTabela.Tables["Cliente"].NewRow();
            
    xdrow["IdCliente"] := 1;
    xdrow["NomeCliente"] := "Dario Martins Bueno Leandro";
    xdrow["EnderecoCliente"] := "Av. Angelica 500";
    xdrow["IdadeCliente"] := "32";
    xdsColecaoTabela.Tables["Cliente"].Rows.Add(xdrow);
            
    var xcount:=1;
    for xcount:=1  to 10 do begin

        xdrow := xdsColecaoTabela.Tables["Pedido"].NewRow();
        xdrow["IdCliente"] := 1;
        xdrow["DataPedido"] := DateTime.Now.AddDays(xcount);
        xdrow["TotalPedido"] := 1000 * xcount;
        xdsColecaoTabela.Tables["Pedido"].Rows.Add(xdrow);
    end;
    {$endregion};

    {$Region Cliente 02}
    xdrow := xdsColecaoTabela.Tables["Cliente"].NewRow();

    xdrow["IdCliente"] := 2;
    xdrow["NomeCliente"] := "Leandro Mattos";
    xdrow["EnderecoCliente"] := "Av. Paulista 600";
    xdrow["IdadeCliente"] := "30";
    xdsColecaoTabela.Tables["Cliente"].Rows.Add(xdrow);

    for xcount:=1  to 6 do begin
            
        xdrow := xdsColecaoTabela.Tables["Pedido"].NewRow();
        xdrow["IdCliente"] := 2;
        xdrow["DataPedido"] := DateTime.Now.AddDays(xcount);
        xdrow["TotalPedido"] := 1000 * xcount;
        xdsColecaoTabela.Tables["Pedido"].Rows.Add(xdrow);
    end;
    {$endregion};

    {$Region Cliente 03}
    xdrow := xdsColecaoTabela.Tables["Cliente"].NewRow();

    xdrow["IdCliente"] := 3;
    xdrow["NomeCliente"] := "Diego Dunit Junior";
    xdrow["EnderecoCliente"] := "Av. Brasil 700";
    xdrow["IdadeCliente"] := "29";
    xdsColecaoTabela.Tables["Cliente"].Rows.Add(xdrow);
    for xcount:=1  to 5 do begin
            
        xdrow := xdsColecaoTabela.Tables["Pedido"].NewRow();
        xdrow["IdCliente"] := 3;
        xdrow["DataPedido"] := DateTime.Now.AddDays(xcount);
        xdrow["TotalPedido"] := 1000 * xcount;
        xdsColecaoTabela.Tables["Pedido"].Rows.Add(xdrow);
    end;
    {$endregion}; 
end;

method MainForm.toolStripButton6_Click(sender: System.Object; e: System.EventArgs);
begin
     {$Region Criar Binding da tabela mestre}
    var xbsMestreCliente:BindingSource  := new BindingSource();
    xbsMestreCliente.DataSource := xdsColecaoTabela;
    xbsMestreCliente.DataMember := xdsColecaoTabela.Tables["Cliente"].TableName;
                     
    {$endregion}

    {$Region Criar Binding da tabela detalhe}
    var xbsDetalhePedido:BindingSource  := new BindingSource();
    xbsDetalhePedido.DataSource := xbsMestreCliente;
    xbsDetalhePedido.DataMember := xdsColecaoTabela.Relations[0].RelationName;
    {$endregion}

    {$Region Navegar}
    dataGridView1.DataSource := xbsMestreCliente;
    dataGridView2.DataSource := xbsDetalhePedido;
    {$endregion} 
end;

end.
